#include <vcl.h>
#include <stdlib.h>
#include <stdio.h>

class WaveFile
{
private:

	unsigned char* wData;
	int wSize;
	int wOffset;
	int wChannels;
	int wBits;
	int wSampleRate;
	int wLengthSamples;

	int RdWord(unsigned char *d) { return d[0]+(d[1]<<8); }

	int RdDWord(unsigned char *d) { return d[0]+(d[1]<<8)+(d[2]<<16)+(d[3]<<24); }

	void WrWord(unsigned char *d,int v) { d[0]=v&255; d[1]=(v>>8)&255; }

	void WrDWord(unsigned char *d,int v) { d[0]=v&255; d[1]=(v>>8)&255; d[2]=(v>>16)&255; d[3]=(v>>24)&255; }

	bool Error(AnsiString message);

public:

	WaveFile();
	~WaveFile();

	bool Load(AnsiString filename);
	bool SaveSelection(AnsiString filename,int start,int end);
	int GetLength(void);
	int GetSampleRate(void);
	int GetSample(int ptr);
};
